void setup () {             // Zwei Schrägstriche: Alles, was von hier bis zum Zeilenende geschrieben wird, ist ein Kommentar und wird vom Arduino nicht beachtet.
                            // Alle Befehle, die innerhalb der geschweiften Klammern vom setup () stehen, werden ein Mal ausgeführt.
                
  pinMode (6, OUTPUT);      // Pin 6 wird als OUTPUT definiert. An OUTPUTs kann der Arduino entweder 5 V (HIGH) oder 0 V (LOW) anlegen.

  }                         // Ende des Setups.


void loop () {              // Start der Schleife. Alles, was innerhalb der Loop steht, wird als Schleife ausgeführt.
  
  digitalWrite (6, HIGH);   // Befehl, der Pin 6 auf HIGH - d.h. 5 V - setzt
  delay (1000);             // delay pausiert den Arduino für den Wert in Milli-Sekunden
  digitalWrite (6, LOW);    // Befehl, der Pin 6 auf LOW - d.h. 0 V - setzt
  delay (1000);              

  }                         // Ende der Schleife. Die Schleife wird jetzt wieder von vorne durchlaufen.



/*  P1_LED-Blinken_16.04.2022
 
    **********************************************************
    AUFGABEN (Hinweise und Lösungen finden Sie am Ende!)
    **********************************************************
   

    1   VORBEREITUNG - Stecken Sie die LED mit Vorwiderstand in Digital-Pin 6 sowie GND. Die Seite mit dem Widerstand kommt in GND, die Seite mit der LED in PIN 6. Andersrum funktioniert die LED nicht. 
        Laden Sie anschließend diesen Sketch unverändert auf den Aruino hoch. Wenn alles geklappt hat, blinkt die LED. 

  
    2   EINSTIEG (z.B. auch als Partneraufgabe) - Machen Sie sich mit dem Programmcode vertraut. 
        Erklären Sie sich oder einer anderen Person den Aufbau des Programms und die einzelnen Programmfunktionen mit eigenen Worten.


    3   BLINKGESCHWINDIGKEIT - Lassen Sie die LED schneller blinken. Ändern Sie hierfür den Programmcode und übertragen Sie ihn anschließend auf den Arduino. 
        
        Tipp: Wo im Programm steht ein Wert für die Zeit? Ändern Sie diesen und laden Sie den Sketch erneut auf den Arduino hoch.


    4   AUFLÖSUNGSFÄHIGKEIT I - Bestimmen Sie die zeitliche Auflösungsfähigkeit des menschlichen Auges (Wahrnehmungsschwelle). 
        Erhöhen Sie hierfür schrittweise die Blinkfrequenz der LED, bis das Blinken nicht mehr von einem Dauerleuchten zu unterscheiden ist.

        Tipp: Wenn Sie das blinken nicht mehr erkennen können, bewegen Sie den Arduino schnell hin und her. Was sehen Sie? Wie können Sie dieses Erklären?
        
   
    5   AUFLÖSUNGSFÄHIGKEIT II (als Partneraufgabe) - Testen Sie mit anderen Personen, ob diese Wahrnehumgsschwelle bei unterschiedlichen Personen identisch ist.


    6   WEITERE LEDS - Verschalten Sie eine weitere LED mitsamt Vorwiderstand mit dem Arduino (z.B. an Pin 10) und lassen Sie beide LEDs im Wechsel blinken. 
        
        Tipp: Sie müssen unter >> void setup << definieren, an welchem Port die zusätzliche LED angesteuert wird und wie sich der Port verhalten soll. 
        Kopieren Sie die entsprechenden Befehle und passen Sie sie an.


    7   DIMMEN VON LEDS I - Dimmen Sie die LED zunächst, anstatt sie direkt auszuschalten. Dies funktioniert nur an den PWM-Ausgängen des Arduinos. Diese sind auf dem Arduino an der kleinen Wellenlinie zu erkennen.
        Verwenden Sie dazu den Befehl  >> analogWrite(6, 100); << und "spielen" Sie mit dem letzten Wert (0-255).


    8   DIMMEN VON LEDS II - Lassen Sie die LEDs nun abswechselnd in kleinen Schritten heller und dunkler werden. Nutzen Sie den Befehl aus der vorherigen Aufgabe und die Delay-Funktion. 


    9   DIMMEN VON LEDS III (Expertenaufgabe) - Optimieren Sie den Programmcode. Programmieren Sie eine LED so, dass sie automatisch per analogwrite heller und dunkler gedimmt wird (d.h. die LED wird erst dunkler bis zu einem bestimmten Wert, dann heller dann wieder dunkler usw.). 
        Verwenden Sie dafür eine Variable die sich ändert. 
        
        Tipp: zunächst Variable "helligkeit" zu Beginn des Sketches definieren, z.B. durch "int helligkeit"). 
        
        Hinweis: Das Programm muss selbstständig erkennen, ob die Variable der Helligkeit ihr Minimum bzw. Maximum erreicht hat und entsprechend reagieren.


    10  DIMMEN VON LEDS IV - Lassen Sie darauf aufbauend zwei LEDs abwechselnd blinken, aber die LEDs wird per analogwrite langsam heller bzw. dunkler. 
        Wenn die eine LED ihre maximale Helligkeit erreicht hat, ist die andere LED aus und umgekehrt.


    11  MORSECODE I - Lassen Sie den Arduino Ihren Namen oder ein beliebiges Wort (z.B. SOS) morsen. Eine Tabelle mit Morsecodes finden Sie z.B. unter en.wikipedia.org/wiki/Morse_code

  
    12  MORSECODE II (Partneraufgabe) - Lassen Sie eine Person einen (kurzen) Morsecode entschlüsseln (dekodieren). 


    13  FUNKTIONEN - Das Morseprogramm ist sicher sehr lang und unübersichtlich. Es wäre übersichtlicher, wenn man direkt Dits und Dahs (d.h. kurze und lange LED-Morsezeichen) aufrufen könnte. 
    
        Definieren Sie dazu im Quellcode Dit und Dah als Funktion. Fügen Sie dazu außerhalb von >> void loop() { ... } << für Dit folgendes ein:

        void DIT() {
        *Befehle, um LEDs an- und auszuschalten*   
        }

        Anschließend können Sie diesen Code an einer beliebien Stelle innerhalb von z.B. void loop mit >> DIT(); << aufrufen 
        und Morsecodes mit DIT();DIT();DIT(); usw. ausführen. Verfahren Sie genauso mit einer Funktion für DAH();


    14  STROBOSKOPEFFEKT (Expertenaufgabe) - Langzeitbelichtungen von blinkenden Lampen oder Stroboskopen sind eine klassische Methode um Bewegungen zu analysieren. 
        Wenn die Lampe (hier LED) gleichmäßig blinkt und auf der Langzeitbelichtung die Abstände zwischen den leuchtenden Lampen gleich sind, ist auch die Geschwindigkeit gleichförmig. 
        Realisieren Sie Experimente, in denen der Arduino mit einer blinkenden LED mit konstanter Geschwindigkeit sowie mit beschleunigter Geschwindigkeit bewegt wird und erstellen Sie 
        eine entsprechende Langzeitbelichtung. 
        
        Tipp: Arduino bspw. am USB-Kabel (oder am besten Bifilar aufgehangen) pendeln lassen, Blinkgeschwindigkeit passend einstellen, Langzeitaufnahme mit Kamera-App. 
  
    
    **********************************************************
    LÖSUNGSHINWEISE
    **********************************************************

    3   BLINKGESCHWINDIGKEIT - LÖSUNGSHINWEISE
    
        - Nach jeder Änderung im Programmcode muss dieser erneut übertragen werden!
        - Das Blinken der LED läuft wie folgt ab: LED einschalten, warten, LED ausschalten, warten, wiederholen. 
        - Ändern Sie beide Werte, die das Programm zwischen Ein- und Ausschalten wartet. 
        - Die Zeitdauer wird in Millisekunden angegeben, für eine halbe Sekunde schreiben Sie bspw. delay(500);
        - Gibt es eine Fehlermeldung? Haben Sie vlt. ein Semikolon ; am Ende der Befehlszeile vergessen?
        - geht vor lauter Fehlermeldungen gar nichts mehr? Laden Sie den Sketch erneut.


    4   AUFLÖSUNGSFÄHIGKEIT I - LÖSUNGSHINWEISE
    
        - Ändern Sie die Werte bei delay (). Das zeitliche Auflösungsvermögen des menschlichen Auges liegt zwischen 30 und 70 Ereignissen pro Sekunde.



    7   DIMMEN VON LEDS - Der Befehl für Dimmen lautet analogWrite(6, 100); er kann zusammen mit einem kurzen delay () hinter den Befehl >> digitalWrite (6, HIGH); << eingefügt werden. 
        Experimentieren Sie mit verschiedenen Werten und bauen den Befehl mehrmals und verringern Sie so schrittweise die Helligkeit.


  
    
    **********************************************************
    LÖSUNGEN
    **********************************************************

    3   BLINKGESCHWINDIGKEIT - LÖSUNG: 
    
        Ändern Sie den Wert bei delay (). Um die LED schneller blinken zu lassen, muss die Pause zwischen dem Blinken verringert werden, bspw. >>  delay (200); <<  

   
    4   AUFLÖSUNGSFÄHIGKEIT I - LÖSUNG
    
        fügen Sie unter >> void setup << folgenden Code hinzu: 
        >> pinMode (10, OUTPUT);  <<
        fügen Sie unter >> void loop << folgenden Code hinzu: 
        digitalWrite (10, HIGH); 
        delay (500);
        digitalWrite (10, LOW);


    13  FUNKTIONEN - LÖSUNG
    
        Fügen Sie unterhalb der Loop-Schleife ein:

        void DIT() {
          digitalWrite (6, HIGH);   
          delay (200);              
          digitalWrite (6, LOW);    
          delay (500);              
        }

        void DAH() {
          digitalWrite (6, HIGH);   
          delay (500);              
          digitalWrite (6, LOW);    
          delay (500);              
        }

        Benutzen Sie anschließend innerhalb der Loop-Schleife die Befehle DIT(); bzw. DAH();, 
        z.B. >> DIT();DIT();DIT();DAH();DAH();DAH();DIT();DIT();DIT(); << für das Morsezeichen SOS


*/
